mui.plusReady(function() {
	document.addEventListener("netchange", isNetworkConnected, false);
});

var nowWebsideUri = function() {

	function localhostIp() {
		return "http://192.168.3.105:8080/camp";
	}

	function remoteIp() {
		return "https://www.forefrontstar.com";
	}

	return remoteIp();
}

var nowApiUri = function() {
	return nowWebsideUri() + "/api/v1"
}

function getRootPath() {
	var pathName = window.location.href;
	var result = (pathName == '' ? '' : pathName.substring(0, pathName.indexOf('/www/')) + '/www');
	return result;
}

function importFile(path) {
	document.write('<script language="javascript" src="' + getRootPath() + path + '"></script>');
}

var httpRequestGet = function(url, synchronous, onloadFunc) {
	var xhr = new plus.net.XMLHttpRequest();
	xhr.open('GET', url, synchronous);
	xhr.timeout = 3000;
	xhr.setRequestHeader('Content-Type', 'application/json');
	xhr.setRequestHeader('Ac cept', 'application/json');
	xhr.onreadystatechange = function() {
		switch(xhr.readyState) {
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				if(xhr.status == 200) {
					onloadFunc(JSON.parse(xhr.responseText));
				} else if(xhr.status == 0) {
					closeWaiting();
					mui.toast("网络不给力！！！");
				} else {
					mui.toast("服务器错误，错误代码:" + xhr.status);
				}
				break;
		}
	}
	xhr.send();
}

var httpRequestPost = function(url, sendJson, synchronous, onloadFunc, btn) {
	if(btn != undefined) {
		var oldLabel = btn.innerHTML;
		btn.innerHTML = "提交中";
		//btn.disabled = true;
	}

	var xhr = new plus.net.XMLHttpRequest();
	xhr.open('POST', url, synchronous);
	xhr.timeout = 3000;
	xhr.setRequestHeader('Content-Type', 'application/json');
	xhr.setRequestHeader('Accept', 'application/json');
	xhr.onreadystatechange = function() {
		switch(xhr.readyState) {
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				if(xhr.status == 200) {
					onloadFunc(JSON.parse(xhr.responseText));
				} else if(xhr.status == 0) {
					closeWaiting();
					mui.toast("网络不给力！！！");
				} else {
					mui.toast("服务器错误，错误代码:" + xhr.status);
				}
				if(btn != undefined) {
					//btn.disabled = false;
					btn.innerHTML = oldLabel;
				}
				break;
		}
	}
	xhr.send(JSON.stringify(sendJson));
}

function closeOthers() {
	// 获取所有Webview窗口
	var curr = plus.webview.currentWebview();
	var wvs = plus.webview.all();
	for(var i = 0, len = wvs.length; i < len; i++) {
		//关闭除当前页面外的其他页面
		if(wvs[i].getURL() == curr.getURL()) {
			continue;
		} else {
			plus.webview.close(wvs[i]);
		}
	}
}

//判断网络是否连接
function isNetworkConnected() {
	var noNetwork = plus.webview.getWebviewById('noNetwork');
	if(noNetwork == undefined) {
		noNetwork = plus.webview.create("noNetwork.html", "noNetwork");
		noNetwork.hide(); // 隐藏窗口
	}
	if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) {
		plus.webview.show("noNetwork");
	} else {
		plus.webview.hide("noNetwork");
	}
}

Array.prototype.contains = function(obj) {
	var i = this.length;
	while(i--) {
		if(this[i] === obj) {
			return true;
		}
	}
	return false;
}

function getCareerLogoURI(name) {
	var array = ["java", "front", "html5", "android", "ios", "linux", "python", "test", "bigdata", "cloudcomputing", "architect"];
	if(array.contains(name) == true) {
		return "/styles/images/career/logo-" + name + ".jpg";
	} else {
		return "/styles/images/career/logo-ffs.jpg";
	}
}

function showWaiting() {
	plus.nativeUI.showWaiting("加载中..."); //显示原生等待框
}

function closeWaiting() {
	setTimeout(function() {
		plus.nativeUI.closeWaiting(); //关闭等待框
	}, 500);
}

function openWindow(id, extras) {
	showWaiting();
	mui.openWindow({
		url: id + '.html',
		id: id,
		extras: extras,
		show: {
			aniShow: 'pop-in'
		},
		styles: {
			popGesture: 'hide'
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	});
}

function openWindowEx(path, id, extras) {
	showWaiting();
	mui.openWindow({
		url: path + id + '.html',
		id: id,
		extras: extras,
		show: {
			aniShow: 'pop-in'
		},
		styles: {
			popGesture: 'hide'
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	});
}

function trim(str) { //删除左右两端的空格
	return str.replace(/(^\s*)|(\s*$)/g, "");　　
}