document.write('<script language="javascript" src="' + getRootPath() + '/scripts/js/ffs/ffs.db.sqlite.js"></script>');

(function($, owner) {
	var db = null;
	var dbName = null;
	var tableName = null;

	/**
	 * 初始化方法
	 */
	owner.init = function() {
		owner.__initDb("campDb", "t_member_info");
	}

	/**
	 * 初始化数据库
	 */
	owner.__initDb = function(dbName, tableName) {
		this.dbName = dbName;
		this.tableName = tableName;

		this.db = new lanxDB(this.dbName);
		this.db.switchTable(this.tableName).dropTable();
		this.db.init(this.tableName, [{
			name: 'id', //主键
			type: 'integer primary key autoincrement'
		}, {
			name: 'entityId', //实体ID
			type: 'integer'
		}, {
			name: 'entitySn', //实体SN
			type: 'text'
		}, {
			name: 'entity', //实体json
			type: 'text'
		}]);
	};

	/**
	 * 往数据库与缓存数组中插入记录
	 *
	 */
	owner.insertRecord = function(entity) {
		var id = this.db.switchTable(this.tableName).insertData([{
			entityId: entity.id,
			entitySn: entity.sn,
			entity: JSON.stringify(entity)
		}]);
		return id;
	};

	owner.findBySn = function(entity) {
		this.db.switchTable(this.tableName).where({
			entitySn: entity.sn
		}).getData(function(result) {
			if(result instanceof Array && result.length > 0) {
				entity = result[0];
			}
		});
		return entity;
	};

	owner.updateBySn = function(entity) {
		this.db.where({
			entitySn: entity.sn
		}).saveData([{
				entityId: entity.id,
				entitySn: entity.sn,
				entity: JSON.stringify(entity)
			}],
			function(result) {
				console.log(result); //影响条数
			});
	};

	/**
	 * 往数据库与缓存数组中插入记录
	 *
	 */
	owner.saveBySn = function(entity) {
		var entityInDb = this.findBySn(entity);
		if(entityInDb == undefined) {
			this.insertRecord(entity);
		} else {
			this.updateBySn(entity);
		}
	};

}(mui, window.memberInfo = {}));